//Fractal_Level_Xrust_V2
//+------------------------------------------------------------------+
//|                                       Fractal_Level_Xrust_V2.mq4 |
//|                                 Copyright  2008, XrustSolution. |
//|                                            http://xrust.ucoz.net |
//+------------------------------------------------------------------+
#property copyright "#Copyright  2008, XrustSolution.#"
#property link      "#xrust.ucoz.net#"

#property indicator_chart_window
extern int    TimeFrame=0;//=0,  


extern string FrApNam="Ap";//  . 
extern string FrDnNam="Dn";//  . 

//-----------------------------------------------------------------------------+
double FrPrise;
double FrApPrise=0,FrDnPrise=0;

//+----------------------------------------------------------------------------+
void init(){
  
  if(TimeFrame==0){TimeFrame=Period();}
  IndicatorShortName("Factal_Level_Xrust"+TimeFrame);
  FrApNam=StringConcatenate(FrApNam,TimeFrame);
  FrDnNam=StringConcatenate(FrDnNam,TimeFrame);
  return;}
void deinit(){
  ObjectDelete(FrDnNam);
  ObjectDelete(FrApNam);
  Comment(" ");
  return;}
//+----------------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int limit;
   double tmp;
   int i, j,k;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//-----------------------------------------------------------------------------+
  
   LineAp();
   LineDn();
   string FAP=DoubleToStr((FrApPrise),Digits);
   string FDP=DoubleToStr((FrDnPrise),Digits);
   int diap=MathRound((FrApPrise-FrDnPrise)/Point);
   {Comment("TimeFrame="+TimeFrame+
                       "\nApPrise111 ="+FAP+
                       "\nDnPrise ="+FDP+
                       "\nFractal Channel ="
                       +diap+"Point");}

   return(0);
  }
//-----------------------------------------------------------------------------+
//               |   
//-----------------------------------------------------------------------------+
   void LineDn(){
   FrPrise=NormalizeDouble(FindNearFractal(0,TimeFrame,MODE_LOWER),MarketInfo(Symbol(),MODE_DIGITS));
   FrPrise=NormalizeDouble(FrPrise,MarketInfo(Symbol(),MODE_DIGITS));
   //Comment(FrPrise);
   if(ObjectFind(FrDnNam)==0){
     if(ObjectGet(FrDnNam,OBJPROP_PRICE1)==FrPrise){return;}}
   FrDnPrise=FrPrise;  
   ObjectDelete(FrDnNam);
   
   WindowRedraw();
   return;} 
//-----------------------------------------------------------------------------+
//               | 
//-----------------------------------------------------------------------------+
   void LineAp(){
   FrPrise=NormalizeDouble(FindNearFractal(0,TimeFrame,MODE_UPPER),MarketInfo(Symbol(),MODE_DIGITS));
   FrPrise=NormalizeDouble(FrPrise,MarketInfo(Symbol(),MODE_DIGITS));
   if(ObjectFind(FrApNam)==0){
     if(ObjectGet(FrApNam,OBJPROP_PRICE1)==FrPrise){return;}}
   FrApPrise=FrPrise; 
   ObjectDelete(FrApNam); 
  
   WindowRedraw();
   return;}
//-----------------------------------------------------------------------------+   
//       !!!                                                |       
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 07.10.2006                                                     |
//|   :   .   .         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy   -        (""  NULL -  )     |
//|    tf   -                      (    0       -  )         |
//|    mode -                    (MODE_LOWER|MODE_UPPER)            |
//+----------------------------------------------------------------------------+
double FindNearFractal(string sy="0", int tf=0, int mode=MODE_LOWER) {
  if (sy=="" || sy=="0") sy=Symbol();
  double f=0;
  int    d=MarketInfo(sy, MODE_DIGITS), s;
  if (d==0) if (StringFind(sy, "JPY")<0) d=4; else d=2;

  for (s=2; s<100; s++) {
    f=iFractals(sy, tf, mode, s);
    if (f!=0) return(NormalizeDouble(f, d));
  }
  Print("FindNearFractal():   ");
  return(0);
}

